// --------------------------------------------------------------------

trait Expression

case class Number(val value: Double) extends Expression
case class Variable(val name: String) extends Expression
case class Binary(val op: String, val left: Expression,
		  val right: Expression) extends Expression
case class Unary(val op: String, val child: Expression) extends Expression
case class Function(val fname: String, val arg: Expression) extends Expression

// --------------------------------------------------------------------
